// 字节跳动面试题目：利用已知函数 add 实现 asyncSum。 

function add (a, b, callback) {
  callback(a + b)
}

async function asyncSum(...args) {
    let result =0
    for(const s of args){
        result = await asyncAdd(result,s)
    }
    return result
}

async function asyncAdd(a,b){
    return new Promise((resolve)=>{
        add(a,b,resolve);
    })
}


(async ()=>{
    const result = await asyncSum(1,2,3,4,5,6)
    
    console.log(result)
})();
